import fr.cnes.genius.constraints.GConstraint;
import fr.cnes.genius.exception.GArithmeticException;
import fr.cnes.genius.exception.GDateFieldException;
import fr.cnes.genius.exception.GException;
import fr.cnes.genius.exception.GIntervalException;
import fr.cnes.genius.interval.GInterval;
import fr.cnes.genius.lowLevel.GPanel;
import fr.cnes.genius.lowLevel.GTime;
import fr.cnes.genius.main.GReadWrite;
import fr.cnes.genius.utils.GPanTest;

public class TestForGTime extends GPanel implements GReadWrite {
    
    private final GTime time;
    
    public TestForGTime () throws GDateFieldException, GArithmeticException {
        
        time  = new GTime("time:");
        time.setInnerDescendantConstraint(new GConstraint(GConstraint.newline(false),  GConstraint.width(200)),1);
        try {
            time.addGInterval(new GInterval(0., 3600.));
        } catch ( GIntervalException e ) {
            // Will never occur
        }
        
    }

    @Override
    public void display() throws GException {
        generic();
    }

    @Override
    public void generic() throws GException {
        try {
            put(time);
        } catch ( Exception e ) {
            e.printStackTrace();
        }
    }

    @Override
    public void read () throws GException {
        generic();
    }

    @Override
    public void write () throws GException {
        generic();
    }

    public static void main(String[] args) throws GDateFieldException, GArithmeticException {
        
        final GPanTest panTest = new GPanTest("GTime", new TestForGTime(),"GTime.xml");
        panTest.display();

        
    }

}
